#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "Params.h"

int fft2 (float a_rl[Y_SIZE][X_SIZE], float a_im[Y_SIZE][X_SIZE], int inv);

/*--- fftfilter --- eesɂ摜̃tB^ ----------------------------
		iX_SIZECY_SIZEQׂ̂̏ꍇɌj
	image_in:	͉摜z
	image_out:	o͉摜z
	deg:		]pixj
	a, b:		ʉߑшiaȏCbȉ̎gʉ߂j
				a=0Cb=X_SIZE=Y_SIZÊƂCSшʉ
-----------------------------------------------------------------------------*/
int fftfilter(unsigned char image_in[Y_SIZE][X_SIZE], 
	unsigned char image_out[Y_SIZE][X_SIZE], int a, int b)
{
	float	*ar;   /*@f[^io͌pj@*/
	float	*ai;   /*@f[^io͌pj@*/
	float	*ff;   /*@tB^̋Ԏg@@*/
	float	data;
	long	i, j, circ;

	ar = (float *)malloc((size_t)Y_SIZE*X_SIZE*sizeof(float));
	ai = (float *)malloc((size_t)Y_SIZE*X_SIZE*sizeof(float));
	ff = (float *)malloc((size_t)Y_SIZE*X_SIZE*sizeof(float));
	if ((ar == NULL) || (ai == NULL) || (ff == NULL)) {
		return -1;
	}
	/* 摜ǂݍ݁CQees̓̓f[^ɕϊ */
	for (i = 0; i < Y_SIZE; i++) {
		for (j = 0; j < X_SIZE; j++) {
			ar[X_SIZE*i + j] = (float)image_in[i][j];
			ai[X_SIZE*i + j] = 0.0;
		}
	}
	/* eessC摜gɕϊ */
	if (fft2((float (*)[X_SIZE])ar, (float (*)[X_SIZE])ai, 1) == -1)
		return -1;
	/* gaȏbȉ̐ʉ߂tB^ */
	for (i = 0; i < Y_SIZE; i++) {
		for(j = 0; j < X_SIZE; j++) {
			data = (float)((j-X_SIZE/2)*(j-X_SIZE/2)
				+ (i-Y_SIZE/2)*(i-Y_SIZE/2));
			circ = (long)sqrt(data);
			if ((circ >= a) && (circ <= b))
				ff[X_SIZE*i + j] = 1.0;
			else
				ff[X_SIZE*i + j] = 0.0;
		}
	}
	/* 摜̎gɑ΂ătB^sȂ */
	for (i = 0; i < Y_SIZE; i++) {
		for (j = 0; j < X_SIZE; j++) {
			ar[X_SIZE*i + j] *= ff[X_SIZE*i + j];
			ai[X_SIZE*i + j] *= ff[X_SIZE*i + j];
		}
	}
	/* teessCtB^ꂽg摜ɖ߂ */
	if (fft2((float (*)[X_SIZE])ar, (float (*)[X_SIZE])ai, -1) == -1)
		return -1;
	/* ʂ摜f[^ɕϊ */
	for (i = 0; i < Y_SIZE; i++) {
		for (j = 0; j < X_SIZE; j++) {
			data = ar[X_SIZE*i + j];
			if (data > 255) data = 255;
			if (data <   0) data = 0;
			image_out[i][j] = (unsigned char)data;
		}
	}
	free(ar);
	free(ai);
	free(ff);
	return 0;
}
