#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>
#include	"Params.h"

int fft2 (float a_rl[Y_SIZE][X_SIZE], float a_im[Y_SIZE][X_SIZE], int inv);

/*--- fftimage --- Qeešʂ摜 -----------------------------
		iX_SIZECY_SIZEQׂ̂̏ꍇɌj
	image_in:	͉摜z
	image_out:	o͉摜zieesj
-----------------------------------------------------------------------------*/
int fftimage(unsigned char image_in[Y_SIZE][X_SIZE], 
	unsigned char image_out[Y_SIZE][X_SIZE])
{
	float  	*ar;		/* f[^io͌pj*/
	float  	*ai;		/* f[^io͌pj*/
	double 	norm, max;
	float	data;
	long	i, j;

	ar = (float *)malloc((size_t)Y_SIZE*X_SIZE*sizeof(float));
	ai = (float *)malloc((size_t)Y_SIZE*X_SIZE*sizeof(float));
	if ((ar == NULL) || (ai == NULL)) return -1;
	/* 摜ǂݍ݁CQees̓̓f[^ɕϊ */
	for (i = 0; i < Y_SIZE; i++) {
		for (j = 0; j < X_SIZE; j++) {
			ar[X_SIZE*i + j] = (float)image_in[i][j];
			ai[X_SIZE*i + j] = 0.0;
		}
	}
	/* Qeess */
	if (fft2((float (*)[X_SIZE])ar, (float (*)[X_SIZE])ai, 1) == -1) return -1;
	/* eesʂ摜 */
	max = 0;
	for (i = 0; i < Y_SIZE; i++) {
		for (j = 0; j < X_SIZE; j++) {
			norm = ar[X_SIZE*i + j]*ar[X_SIZE*i + j] 
			     + ai[X_SIZE*i + j]*ai[X_SIZE*i + j];	/* UvZ */
			if (norm != 0.0) norm = log(norm) / 2.0;
			else norm = 0.0;
			ar[X_SIZE*i + j] = (float)norm;
			if (norm > max) max = norm;
		}
	}
	for (i = 0; i < Y_SIZE; i++) {
		for (j = 0; j < X_SIZE; j++) {
			ar[X_SIZE*i + j] = (float)(ar[X_SIZE*i + j]*255 / max);
		}
	}
	/* eesʂ摜f[^ɕϊ */
	for (i = 0; i < Y_SIZE; i++) {
		for (j = 0; j < X_SIZE; j++) {
			data = ar[X_SIZE*i + j];
			if (data > 255) data = 255;
			if (data <   0) data = 0;
			image_out[i][j] = (unsigned char)data;
		}
	}
	free(ar);
	free(ai);
	return 0;
}
